<?php
namespace Zeedhi\DevOps\Model\Projectmanagement\Repositories;


use Zeedhi\DevOps\Util\Utilities;
use Zeedhi\DevOps\Model\Projectmanagement\Entities;

class TaskWorkitem extends \Doctrine\ORM\EntityRepository{

    public function findItemtrab($organizationId, $filtersString = '', $limit = null, $offset = null){
        $query = <<<SQL
        SELECT * FROM (
            SELECT CDREDUITTRAB, NMITEMTRAB, CDITEMTRAB, NRCPLXITTRAB
              FROM ITEMTRAB
          ORDER BY NMITEMTRAB)
        WHERE 1=1
        $filtersString
SQL;
        $params = array(
            'organizationId' => $organizationId
        );
        $query = Utilities::getPaginatedQuery($query, $limit, $offset);
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function findItemtrabRelatedToIssuesByTaskId($organizationId, $taskId, $filtersString = '', $limit = null, $offset = null){
        $query = <<<SQL
            SELECT RTRIM(XMLAGG(XMLELEMENT(E,TW.CDITEMTRAB,',').EXTRACT('//text()') ORDER BY TW.CDITEMTRAB).GETCLOBVAL(),',') AS CDITEMTRAB
              FROM TASK_WORKITEM TW
             WHERE TASK IN (SELECT TR.TASK
                              FROM TASK_RELATIONSHIP TR
                             WHERE TR.TASK_RELATIONSHIP = :taskId 
                               AND TYPE = :RELATIONSHIP_ISSUE_TYPE)
SQL;
        $params = array(
            'organizationId' => $organizationId,
            'taskId' => $taskId,
            'RELATIONSHIP_ISSUE_TYPE' => Entities\TaskRelationship::RELATIONSHIP_ISSUE_TYPE,
        );
        $query = Utilities::getPaginatedQuery($query, $limit, $offset);
        $result = $this->getEntityManager()->getConnection()->fetchAll($query, $params);
        foreach ($result as &$row) {
            $row['CDITEMTRAB'] = Utilities::setSelectMultiInQuery($row['CDITEMTRAB']);
        }
        return $result;
    }
}
